<?php
require_once("DBManager.class.php");

class enlace{
	private $idenlace;///
	private $idpersona;	
	private $titulo;
	private $url;
	private $visible;
	private $fechareg;
	private $idpercomparte;
	
	//////////////////////////////////////////
	public function Correlativo()
	{
		$vCorre2 = 1;		
		$vCont = 1;
		$vCeros = "";
		$delta_ceros = 0;
		$AnoSiguiente = 0;
		$AnoActual = 0;
		$fecha = getdate();
		
		$db= new DBManager();	
		$rs=$db->execute("SELECT idenlace FROM enlace ORDER BY idenlace;");
		
		//Entra a este bloque si existe algun valor en el campo INroOrd		
		if($rs->lastRow())
		{			
			
		
			$vCorre1 = substr($rs->fields['idenlace'],0,5);//variable que almacena los 4 primeros caracteres de INroOrd
			$vCorre2 = substr($rs->fields['idenlace'],6); //extraigo los ultimos 5 caracteres de INroOrd 			
			
			$vCorre1 = intval($vCorre1); //obtengo el valor entero
			$vCorre2 = intval($vCorre2); //obtengo el valor entero
							
			$vCorre2++;//se incrementa en 1, es decir el correlativo
			
			//verifico si el correlativo llega a ocupar los 5 digitos
		 	$delta_ceros = 6 - strlen($vCorre2);
			
			if( $delta_ceros == 0 )// Si en el codigo  correlativo ya no existen ceros que poner es decir vCorre2 = 10000
			{
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{

						return ($vCorre1.$vCorre2);
					}			
			}
			
			if( $delta_ceros < 0 /*-1*/)// Si en el codigo correlativo ya no existen ceros que poner y ya llego al limite, en este caso delta_ceros = -1
			{
				$AnoSiguiente = $vCorre1+=1;
				return $AnoSiguiente."0000001";
			}
			
			if( $delta_ceros > 0) // Si en el codigo correlativo existen ceros que poner
			{
			
				//Si es que he pasado al siguiente año
				$AnoActual = intval($fecha['year']);
				if($AnoActual>$vCorre1)
				{   
					$AnoSiguiente = $vCorre1+=1;
					return $AnoSiguiente."0000001";
				}
				else{
						for($i=1; $i<$delta_ceros; $i++)
						{
							$vCont++;//contador de ceros
						}			
						$vCeros=str_pad($vCeros,$vCont,'0',STR_PAD_RIGHT);//rellenar de ceros al lado derecho		
						return($vCorre1.$vCeros.$vCorre2);
					}			
			}			

		}else{ 
				//Caso contrario esta vacio el campo al inicio de las acciones				
				return ($fecha['year']."000000".$vCorre2);				
			 }

		$rs->close();
		$db->closeConnection();//opcional			
	}
	
	///////////////////////////////////////////
	public function Crear($vi,$vid,$ti,$de,$es,$idpc)
	{   
		$resp=false;		
		$db= new DBManager();		
		if($db->_execute("INSERT INTO enlace(idenlace,idpersona,titulo,url,visible,idpercomparte) VALUES('".$vi."',".$vid.",'".$ti."','".$de."','".$es."',".$idpc.")"))   
		{
			$resp=true;
		}
		return $resp;		
	}
	
	public function Comparte($vi,$vid,$ti,$de,$es,$idpc)
	{   
		$resp=false;		
		$db= new DBManager();		
		if($db->_execute("INSERT INTO enlace(idenlace,idpersona,titulo,url,visible,idpercomparte) VALUES('".$vi."',".$vid.",'".$ti."','".$de."','".$es."',".$idpc.")"))   
		{
			$resp=true;
		}
		return $resp;		
	}
	
	
	public function ListarPorPersona($v)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from enlace where(idpersona =".$v.") order by idenlace desc");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListarPublicos($v)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from enlace where titulo LIKE CONCAT('%','".$v."','%') and visible ='PUBLICO' order by idenlace desc");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListaPaginadaPublicos($vcli,$limitInf,$tampag)
	{    /////////////////////////////////////
		$vector=null;		
		$db= new DBManager();			
		$rs=$db->execute("SELECT * FROM enlace WHERE titulo LIKE CONCAT('%','".$vcli."','%') and visible='PUBLICO' ORDER BY idenlace desc limit ".$limitInf.",".$tampag.";");			
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{    
   				$vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListarPorTitulo($v,$idp)
	{
		$vector=null;		
		$db= new DBManager();		
		$rs=$db->execute("select * from enlace where titulo LIKE CONCAT('%','".$v."','%') and idpersona =".$idp." ");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{
   				$vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
	
	public function ListaPaginada($vcli,$idp,$limitInf,$tampag)
	{    /////////////////////////////////////
		$vector=null;		
		$db= new DBManager();			
		$rs=$db->execute("SELECT * FROM enlace WHERE titulo LIKE CONCAT('%','".$vcli."','%') and idpersona =".$idp."  ORDER BY idenlace desc limit ".$limitInf.",".$tampag.";");			
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) 
			{    
   				$vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
         	}			
        	return $vector;			
		}else return null;
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}
		
	public function BuscarPorCodigo($vcod)
	{
		
		$resp=false;
		$num_rows=0;//numero de filas afectada por la consulta
		$db= new DBManager();
		$rs=$db->execute("select * from enlace where(idenlace = '".$vcod."')");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$resp=true;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) {
                // Coleccion de campos accesible mediante arrays asociativos también
	                  $this->idenlace=$rs->fields["idenlace"];
				      $this->idpersona=$rs->fields["idpersona"];	
					  $this->titulo=$rs->fields["titulo"];				
				      $this->url=$rs->fields["url"];			 
				      $this->visible=$rs->fields["visible"];
					  $this->idpercomparte=$rs->fields["idpercomparte"];
 				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
        	}			
		}
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              
		return $resp;							
	}
	
	
	public function Actualizar($vi,$ti,$de,$es)			
	{
		$resp=false;		
		$db= new DBManager();	
		$vf = implode("-",array_reverse(explode("-",$vf)));	
		if($db->_execute("update enlace set titulo = '".$ti."',url = '".$de."',visible='".$es."' where (idenlace=".$vi.") "))//si es exitosa la consulta			   
		{
		  $resp=true; 
		}	
		return $resp;
	}
	////////////////////////////////*/
	public function ListaTotal()
	{
		$vector=null;
		$db= new DBManager();		
		$rs=$db->execute("select * from enlace order by idenlace desc");
		$num_rows=$rs->getNumOfRows();
		if($num_rows>0)
		{	$row=0;
			$rs->firstRow(); // opcional, pero recomendado
			while (!$rs->EOF) {
                $vector[$row]=array("idenlace"   => $rs->fields["idenlace"],
									"idpersona" 	    => $rs->fields["idpersona"],
									"titulo"         => $rs->fields["titulo"],
									"url"         => $rs->fields["url"],
									"visible"         => $rs->fields["visible"],
									"idpercomparte"         => $rs->fields["idpercomparte"]);
									
                $row++;
				$rs->nextRow(); // Nota: nextRow() Esta situado al final				
        	}			
        	return $vector;			
		}else return null;
		
		$rs->close(); 
		$db->closeConnection();//opcional cierra el enlace de la Base de Datos              						
	}	

	//////////////////////////////
	public function Eliminar($vcod)
	{
		$resp=false;		
		$db= new DBManager();		
		if($db->_execute("DELETE FROM enlace WHERE (idenlace='".$vcod."');"))   
		{
			$resp=true;
		}
		return $resp;		
	}	
	////////////////////////////////////////							
	
	public function getIdenlace(){ return $this->idenlace;}
	public function getIdpersona(){ return $this->idpersona;}
	public function getTitulo(){ return $this->titulo;}
	public function getUrl(){ return $this->url;}
	public function getVisible(){ return $this->visible;}
	public function getidpercomparte(){ return $this->idpercomparte;}
}
?>
